local ent = ents.Derive("base")

local angle = 0

local square = love.graphics.newImage ( "assets/images/square.png" )
local circle = love.graphics.newImage ( "assets/images/circle.png" )
local star = love.graphics.newImage ( "assets/images/star.png" )

function ent:setPos( x, y )
	self.x = x
	self.y = y
end

function ent:setSize( size )
	self.size = 32
end

function ent:getHitboxSize()
	hitboxSize = self.size
	return hitboxSize
end

function ent:getMultiplier()
	local multipliers = { 1, 1.5, 2 }
	self.multiplier = multipliers[love.math.random(#multipliers)]
	return self.multiplier
end

function ent:getSize()
	return self.size
end

function ent:setImage()
	local shapes = { square, circle, star }
	self.image = shapes[love.math.random(#shapes)] or love.graphics.newImage ( "assets/images/missing.png" )
	return self.image
end

function ent:setColor()
	local colors = {
		{110,194,255},
		{255,79,79},
		{255,225,79},
		{255,144,71},
		{189,58,255},
		{58,255,81}
	}
	self.color =  colors[love.math.random(#colors)]
	return self.color
end

function ent:drawImage()
	love.graphics.setColor(self.color)
	love.graphics.draw( self.image, self.x, self.y, 0.2, self.multiplier-0.5, self.multiplier-0.5, 32, 32)
	love.graphics.setColor(255,255,255,255)
end

function ent:load( x, y )

	--color =
	self:setPos( x, y )
	self:setSize(32)
	self:setImage()
	self:setColor()
	self:getHitboxSize()
	self:getMultiplier()
end

function ent:update(dt)
	self.y = self.y + (self.multiplier/2)*2.5
	if (self.y >= 768+64) then
		ents.remove( self.id )
	end
end

function ent:dead()

end

function ent:draw()
	ent:drawImage()
end

return ent;